{

  ************************************************************************
  *                                                                      *
  *  entropia v1.0 by Ippatsu Man                                        *
  *                                                                      *
  *  This program can be distributed under the terms of the GNU General  *
  *  Public License. But, above all, give credit where credit is due.    *
  *                                                                      *
  ************************************************************************

  TO-DO:
  * Ottimizzare la routine principale del thread. Il metodo che ho
    usato  assolutamente repellente (anche se funzionale). Penso si
    possa scendere sotto gli 8 secondi per 30Mb senza sforzi eccessivi.
    Poi si possono usare puntatori al posto degli array e quant'altro...
  * Dare la possibilit all'utente di interrompere l'elaborazione. Questo
     proprio semplicissimo. Non l'ho implementato solo per stimolarvi
    un po' le cerebra.
  * Aggiungere un grafico con la frequenza di ogni byte. Anche questo 
    abbastanza banale
  * Per i puristi dell'OOP bisognerebbe riscrivere il tutto in chiave
    pi Object-Oriented; in effetti ho combinato davvero delle porcherie,
    tipo accedere direttamente al memo dall'interno del thread e passare
    i parametri in modo grezzissimo
  * Tutto il  codice  che modifica  oggetti  VCL dall'interno  del  thread
    dovrebbe essere incapsulato in  procedure apposite e richiamato usando
    la procedura Synchronize(Method: TThreadMethod);
  * rendere il tutto pi tollerante alla eccezioni. Gi cos com'
    dovrebbe essere in grado di gestire un po' di tutto, magari si
    potrebbe informare l'utente di ci che succede
  * eliminare i bug che sicuramente mi sono sfuggiti

  Ovviamente lascio tutti questi compiti al lettore...

}

unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls;

type
  TArrayExt = array[0..255] of Extended;

  Tmainfrm = class(TForm)
    etInput: TEdit;
    btOpen: TButton;
    OpenDialog: TOpenDialog;
    btElabora: TButton;
    Memo1: TMemo;
    pbProgress: TProgressBar;
    btAbout: TButton;
    procedure btOpenClick(Sender: TObject);
    procedure etInputChange(Sender: TObject);
    procedure btElaboraClick(Sender: TObject);
    procedure OnEnding(Sender: TObject);
    procedure btAboutClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    Freq: TArrayExt;
    Med: TArrayExt;
    Ent: Extended;
  end;

  TProcessa = class(TThread)
  private
    function Log2(X: Extended): Extended;
  public
    FFile: string;
    procedure Execute; override;

  end;

var
  mainfrm: Tmainfrm;
  th: TProcessa;

implementation

uses about;

{$R *.DFM}

//----------------------------------------------------------------------

procedure TProcessa.Execute;
CONST TMAX=8192;                 // numero di byte da leggere in ogni blocco 8192 = 8kb
                                 // volendo potete provare a cambiarlo ma io penso
                                 // che questo sia il valore ottimale. Forse
                                 // si possono provare anche blocchi da 16384 (16kb)
                                 // ma non consiglio di andare troppo oltre...

var
  length,z,i,volte:integer;       // length = dimensione del file
                                  // z,i = contatori per i cicli
  temp:array[0..TMAX-1] of byte;  // array che funge da buffer
  templines:TStringList;          // deposito temporaneo per i risultati del thread
  time:dword;                     // variabile per calcolare il tempo impiegato
  buf:byte;                       // buffer di un byte
  F:TFileStream;                  // questo  l'oggetto per accedere al file
begin
  if FileExists(FFile) then       // controlliamo che il file esista
  begin
    time:=GetTickCount; // usiamo l'api GetTickCount per mettere in
                        // time il numero di millisecondi passati
                        // dall'avvio di Windows
    buf:=0; // per sicurezza azzeriamo questo mini-buffer
    mainfrm.pbProgress.Position:=0; // poniamo a zero la progress bar
    mainfrm.Ent:=0;  // azzeriamo il risultato

    {
     nel ciclo qui sotto azzeriamo i due array
     in med andranno le frequenze, in freq i valori che andranno nella sommatoria
     (mi sono accorto che i nomi erano al contrario dopo aver sviluppato
     tutto il programma, e sono troppo pigro per cambiare il nome di due variabili =)
     }
    for z:=0 to 255 do
    begin
      mainfrm.Med[z]:=0;
      mainfrm.Freq[z]:=0;
    end;

    // creiamo il TFileStream
    F:=TFileStream.Create(FFile,fmOpenRead);
    try
      length:=F.Size; // in length la dimensione del file
      mainfrm.pbProgress.Max:=length; // il massimo della progress bar  uguale
                                      // alle dimensione del file
      mainfrm.pbProgress.Step:=TMAX;  // uno "step" della barra = un blocco

    {
      ora un piccolo inciso su come ho deciso di implementare l'algoritmo
      Il primo tentativo era stato quello di leggere un byte alla volta.
      Risultato: una lentezza sconfortante
      Allora ho deciso di fare cos: conto quanti blocchi di TMAX byte sono
      contenuti nel file, per ogni blocco, lo leggo e lo metto nel buffer
      temp ed esamino quello per vedere quali byte sono contenuti.
      Poi leggo un byte alla volta fino ad arrivare alla fine del file
      (per 8192 byte non  una perdita di tempo eccessiva).
      Ad esempio: file da 3645150 byte
                  444 blocchi da 8kb
                  7902 byte da leggere alla fine
      infatti: (444*8192)+7902=3645150

      Se avete domande mailatemi: ippatsu_man@hotmail.com
    }

      volte:=F.Size div TMAX;  // contiamo quanti blocchi da TMAX byte ci sono
      if volte>0 then   // se c' almeno un blocco...
      begin
          for i:=1 to volte do  // ...per ogni blocco..
          begin
          F.Read(temp,TMAX);  // ...lo leggiamo e lo mettiamo in temp...
          for z:=0 to TMAX-1 do  // ...scandiamo temp...
            mainfrm.Med[temp[z]]:=mainfrm.Med[temp[z]]+1;
            {
              azz!  solo una linea di codice e non riesco a sintetizzarla!!
              Allora: temp[z] contiene il byte letto. Prendiamo, dall'array Med,
              l'elemento numero temp[z] e incrementiamo il suo valore di uno.
              In pratica Med[0] conterr il numero di byte con valore 0x00
              (o $00 per i Delphisti =)), Med[1] il numero di byte con valore
              0x01 e cos via...
            }
          mainfrm.pbProgress.StepIt;  // mandiamo avanti la progress bar
        end;
      end;
      // ok, arrivati qui abbiamo elaborato tutti i blocchi di TMAX byte
      // rimarranno alla fine del file una manciata di byte, che elaboreremo
      // uno ad uno
      while F.Position<F.Size do
      begin
        F.Read(buf,1);
        mainfrm.Med[buf]:=mainfrm.Med[buf]+1;
        //  la stessa solfa di prima, solo un byte alla volta...
      end;
      // portiamo alla fine la progress bar
      mainfrm.pbProgress.Position:=mainfrm.pbProgress.Max;
    finally
      F.Free;  // anche in caso di errori distruggiamo l'oggetto F
               // (maledetti memory leak!!)
    end;

    // da qui iniziamo il vero calcolo della formula di Shannon
    if length>0 then  //se il file ha almeno un byte...
      for z:=0 to 255 do
      begin
        // prendiamo ogni elemendo di med e dividiamo il
        // suo valore per il numero di byte del file
        // in questo modo mettiamo in med[z] la frequenza
        // di ogni byte espressa in forma decimale
        mainfrm.Med[z]:=mainfrm.Med[z]/length;

        // ora moltiplichiamo med[z] per il suo logaritmo in
        // base 2 e lo mettiamo in Freq[z]
        if mainfrm.Med[z]>0 then  // controlliamo che med[z] sia
                                  // diverso 0 perch il logaritmo
                                  // di 0   - oo (meno infinito)
          mainfrm.Freq[z]:=(mainfrm.Med[z] * Log2(mainfrm.Med[z]));
      end
    else
      for z:=0 to 255 do
      begin
        mainfrm.Med[z]:=0;
        mainfrm.Freq[z]:=0;
        // se la dimensione del file  0
        // poniamo a zero tutti gli elementi dell'array
      end;

    // in time mettiamo i millesimi di secondo trascorsi
    time:=GetTickCount-time;

    // creiamo una StringList temporanea...
    templines:=TStringList.Create;
    try
      templines.Add('');    
      templines.Add('-----------------------------------------------------');
      templines.Add('');
      for z:=0 to 255 do
      begin
        mainfrm.Ent:=mainfrm.Ent+mainfrm.Freq[z];  // effettuiamo la sommatoria
        templines.Add(format('0x%.2x = %.5f %s',[z, mainfrm.Med[z]*100, '%']));
        // scriviamo la frequenza percentuale di ogni byte
        // la riga qui sopra pu sembrare complessa a chi preferisce usare
        // la procedura concat del pascal (come me fino a poco tempo fa)
        // o non conosce per nulla il C. Comunque mi sono da poco convertito
        // all'uso di format per la sua eleganza
      end;
      mainfrm.Ent:=-mainfrm.Ent; // tutti i valori di Freq sono negativi, quindi
                                     // la sommatoria restituisce un valore negativo
                                     // ma l'entropia  sempre positiva, quindi
                                     // Ent:= -Ent (cambiamo segno ad Ent)
      templines.Add('');
      templines.Add('-----------------------------------------------------');
      templines.Add('');

      // bhe... le righe qui sotto mi sembra si commentino da sole...
      templines.Add(format('Nome del file: %s',[ExtractFileName(FFile)]));
      templines.Add(format('Dimensioni del file: %d bytes',[length]));
      templines.Add(format('Tempo impiegato per l''elaborazione: %d ms',[time]));
      // aggiungiamo l'entropia assoluta, cio la media dell'entropia per byte
      templines.Add(format('Entropia assoluta: %.5f',[mainfrm.Ent]));
      // dividiamo l'entropia assoluta per 8 (i bit di un byte) moltiplichiamo
      // per 100, in modo da avere l'entropia relativa in percentuale
      templines.Add(format('Entropia relativa: %.5f %s',[mainfrm.Ent/8*100,'%']));

      // copiamo templines all'interno del memo
      mainfrm.Memo1.Lines.Assign(templines);

      // le due righe qui sotto servono per far scrollare alla fine
      // il memo della form
      mainfrm.Memo1.Lines.Add('');
      mainfrm.Memo1.Lines.Delete(mainfrm.Memo1.Lines.Count-1);
    finally
      templines.Free; // eliminiamo l'oggetto templines
    end;
  end else
  begin
    MessageBoxA(mainfrm.Handle,'Il file specificato non esiste','Entropia v1.0',MB_ICONSTOP);
    mainfrm.Memo1.Lines.Clear;
    // se il file di input non esiste insultiamo l'utente
    // e cancelliamo il contenuto del memo
  end;
end;

{
 la funzione qui sotto serve per calcolare il logaritmo in base 2 di una
 variabile di tipo extended. Non chiedetemi come funziona perch NON LO
 SO!! L'ho solo copiata dalla unit math di delphi. L'ho riportata qui
 perch non tutte le versioni di delphi hanno questa unit. Comunque
 ho fatto dei test e ho visto che  abbastanza veloce (impiega meno di
 un millesimo di secondo per ogni chiamata), quindi non mi  sembrato
 opportuno sostituirla con una routine di approssimazione.
 E poi viene chiamata relativamente poche volte (256).
}
function TProcessa.Log2(X: Extended): Extended;
asm
        FLD1
        FLD     X
        FYL2X
        FWAIT
end;

//----------------------------------------------------------------------

procedure Tmainfrm.OnEnding(Sender: TObject);
begin
  mainfrm.btElabora.Enabled:=true;
  mainfrm.btOpen.Enabled:=true;

  // vabb questa  proprio un'ovviet!!
  // per i pi cerebrolesi: quando viene chiamata questa procedura
  // cio quando termina il thread, i pulsanti per aprire un nuovo
  // file e per avviare l'elaborazione vengono riabilitati
end;

procedure Tmainfrm.btOpenClick(Sender: TObject);
begin
  if OpenDialog.Execute then
    etInput.Text:=OpenDialog.FileName;

  // avviamo l'opendialog. Se viene selezionato un file
  // ne copiamo il nome nell'edit
end;

procedure Tmainfrm.etInputChange(Sender: TObject);
begin
  btElabora.Enabled:=FileExists(etInput.Text) and (UpperCase(etInput.Text)<>UpperCase(Application.ExeName));

  // perch il pulsante per avviare l'eleaborazione sia abilitato
  // il file indicato nell'edit deve esistere e non deve essere
  // l'eseguibile stesso (altrimenti c' un bel BSOD)
end;

procedure Tmainfrm.btElaboraClick(Sender: TObject);
begin
  btElabora.Enabled:=false;   // diasbilitiamo il pulsante per l'elaborazione
  btOpen.Enabled:=false;      // e quello per aprire altri file
  th:=TProcessa.Create(true); // creiamo il thread in modalit sospesa
  th.FFile:=etInput.Text;     // impostiamo il nome
  th.FreeOnTerminate:=true;   // settiamo a true la propriet FreeOnTerminate
                              // in modo che non sia necessario chiamare th.Free
  th.OnTerminate:=mainfrm.OnEnding;  // quando il thread termina chiama la procedura OnEnding
  th.Resume;  // avviamo il thread!
end;


// questa  la procedura per mostrare l'about box
procedure Tmainfrm.btAboutClick(Sender: TObject);
var aboutform:Tfrmabout;
begin
  aboutform:=Tfrmabout.Create(mainfrm);
  try
    aboutform.ShowModal;
  finally
    FreeAndNil(aboutform);
    // se avete una versione inferiore alla 5 di Delphi
    // utilizzate questo codice:
    {
    aboutform.Free;
    aboutform:=nil;
    }
  end;
end;

end.
